// KatibPreviewController is exposed via WebScriptObject
document.addEventListener('DOMContentLoaded', function(event) {
	if ( typeof KatibPreviewController !== 'undefined' ) {
		KatibPreviewController.refreshPreview();
	}
});

function KatibSetHTMLWritingDirection(direction) {
	document.getElementsByTagName('html')[0].setAttribute('dir', direction);
}

function KatibSetCSS(cssCodeBlock) {
	var el = document.getElementById("KatibStyleElement");
	var orphan = false;

	if ( !el ) {
		orphan = true;
		el = document.createElement('style');
		el.setAttribute("id", "KatibStyleElement");
	}

	var cssTextNode = document.createTextNode(cssCodeBlock);
	if ( el.firstChild ) {
		el.replaceChild(cssTextNode, el.firstChild);
	} else {
		el.appendChild(cssTextNode);
	}

	if ( orphan ) {
		var headEl = document.getElementsByTagName('head')[0];
		headEl.insertBefore(el, headEl.firstChild);
	}
}

function KatibSetOptionalCSS(cssCodeBlock) {
	var el = document.getElementById("KatibOptionalStyleElement");
	var orphan = false;

	if ( !el ) {
		orphan = true;
		el = document.createElement('style');
		el.setAttribute("id", "KatibOptionalStyleElement");
	}

	var cssTextNode = document.createTextNode(cssCodeBlock);
	if ( el.firstChild ) {
		el.replaceChild(cssTextNode, el.firstChild);
	} else {
		el.appendChild(cssTextNode);
	}

	if ( orphan ) {
		document.getElementsByTagName('head')[0].appendChild(el);
	}
}

function KatibSetMarkup(HTMLContent) {
	document.getElementsByTagName('body')[0].innerHTML = HTMLContent;
}